import subprocess
import tempfile
import genkey # provided for this challenge

def crack_key(gc):
    """compute the private key of a given Graphcrypt instance"""
    with tempfile.NamedTemporaryFile(mode='w') as formula:


        def add_clause(vertices):
            formula.write('%s 0\n' %
                          ' '.join(str(v if v < 0 else v + 1) for v in vertices))


        for vertex, neighbors in enumerate(gc.pubkey):
            add_clause([vertex] + neighbors)


            for neighbor in neighbors:
                add_clause([~vertex, ~neighbor])


                for neighbor2 in neighbors:
                    if neighbor != neighbor2:
                        add_clause([~neighbor, ~neighbor2])


        formula.flush()
        solver = subprocess.Popen(['cryptominisat', formula.name],
                                  stdout=subprocess.PIPE)
        solver.wait()
        output = solver.stdout.read().split('\n')


        solution = [line for line in output if line.startswith('v ')][0]
        gc.privkey = [ int(var) - 1
                       for var in solution.split()[1:-2]
                       if not var.startswith('-') ]


gc = genkey.Graphcrypt(fil='pubkey')
crack_key(gc)
with open('ciphertext', 'rb') as ciphertext:
    print ('%x' % gc.decrypt(ciphertext.read())).decode('hex')

